services/API_Gateway/project/__init__.py
import uuid
from flask import Flask, jsonify
from flask_restful import Api

from .api.views import bp as feBp
from .api.api_methods import bp as apiBp
from .api.api_methods import *
import config

app = Flask(__name__)
app.secret_key = str(uuid.uuid4())

api = Api(apiBp)
api.add_resource(Methods, '/<path:serv_path>/', '/', '/<path:serv_path>/<path:param>/')

app.register_blueprint(feBp)  # front-end blueprint
app.register_blueprint(apiBp, url_prefix=config.API_PREFIX) # api blueprint

services/API_Gateway/project/api/views.py
from flask import (
    Blueprint, render_template,
    request, flash, redirect,
    url_for
)
from flask import current_app as ca

from ..utils.database import *
# import config


bp = Blueprint('views', __name__)


def extract_records(req):
    """Extract info of a service from html form data

    Args:
        req: request object

    Returns:
        dict: service info
    """

    serv = {
        "NAME": req.form["apiName"].capitalize(),
        "URL": req.form["serverURL"],
        "AUTH_CHECK_API": req.form["AuthCheckAPI"],
        "API_SECRET": req.form["apiSecret"],
        "DESC": req.form["apiDesc"].capitalize(),
    }

    routes = []
    path_list = req.form.getlist("path[]")
    service_path = req.form.getlist("servicePath[]")
    method_list = req.form.getlist("Method[]")
    auth_list = req.form.getlist("authRequired[]")
    pathDesc_list = req.form.getlist("pathDesc[]")
    i = 0

    while i < len(path_list):
        tmp = {}
        tmp["servicePath"] = service_path[i].lower()
        tmp["path"] = path_list[i].lower()
        tmp["method"] = method_list[i].upper()
        tmp["authRequired"] = auth_list[i]
        tmp["pathDesc"] = pathDesc_list[i].capitalize()
        routes.append(tmp)
        i += 1
    serv["ROUTES"] = routes
    ca.logger.debug("Service: ", serv)
    return serv


@bp.route("/")
def home():
    """Home page"""

    return render_template('home.html', title='Welcome')


@bp.route("/add")
def add():
    """Adding new service page"""

    return render_template('add.html', title='Add endpoints ')


@bp.route("/add_to_db", methods=["POST"])
def add_to_db():
    """Adding the new service into DB."""

    if request.method == "POST":
        serv = extract_records(request)
        err = add_service(**serv)
        if isinstance(err, list):
            for e in err:
                flash(str(e)+" is duplicate", 'Error')
            return redirect(url_for('views.add'))
        elif err:
            flash(str(err), 'Error')
            return redirect(url_for('views.add'))
        else:
            flash("Successfully added the service.", "Success")
            return redirect(url_for('views.add'))


@bp.route("/services")
def all_services():
    """The page for list of all the available service page."""

    rec, total = get_all_services(page=0, limit=0)
    # for r in rec:
    #     print(type(r))
    return render_template("services.html", records=rec)


@bp.route("/view/<serv>")
def view_service(serv):
    """The page to view A serive info"""

    return render_template("view_service.html", records=get_serv_info(serv), prefix=config.API_PREFIX)


@bp.route("/del_emp", methods=['POST'])
def del_emp():
    """Deletes a service document/record."""

    if request.method == 'POST':
        serv_name = request.form["Delete"]
        done = del_serv_doc(serv_name)

        if done is False:
            flash("Service doesn't exist", 'error')
            return redirect(url_for('views.all_services'))

        flash("Employee record has been deleted.", 'info')
        return redirect(url_for('views.all_services'))


@bp.route("/update", methods=["POST", "GET"])
def update_page():
    """The update page"""

    if request.method == "POST":
        serv_name = request.form['Edit']
        # info = get_serv_info(serv_name)
        return render_template("update.html", records=get_serv_info(serv_name), title="Update employee details")


@bp.route("/update_serv", methods=["POST"])
def update_serv():
    """Update the service info (in the DB)."""

    if request.method == 'POST':
        org_service_name = request.form["Edit"]
        service = extract_records(request)
        err = update_record(name=org_service_name, **service)
        if isinstance(err, list):
            for e in err:
                flash(str(e)+" is duplicate", 'Error')
            # return render_template('update.html', records=request.form, title="Update the Service Details")
            return redirect(url_for('views.update_page'), code=307)
        elif err:
            flash(str(err), 'info')
            # return render_template('update.html', records=request.form, title="Update the Service Details")
            return redirect(url_for('views.update_page'), code=307)
        flash("Update Successful.", 'info')
        return redirect(url_for('views.view_service', serv=service["NAME"]),)

services/API_Gateway/project/templates/add.html
<!DOCTYPE html>
<html lang="en">
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

    <!-- Optional theme -->
    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
    <link rel="stylesheet" href="../static/fa/css/font-awesome.min.css">

    <title>{{title}}</title>
</head>
<body>
{% include 'navbar.html' %}
<br/>

{% with messages = get_flashed_messages(with_categories=True) %}
{% if messages %}
{% for cat, msg in messages %}

<div class="container">
    <div class="alert alert-warning alert-dismissible fade show" role="alert">
        <strong>{{ cat.capitalize() }}: </strong> {{ msg }}
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
</div>
{% endfor %}
{% endif %}
{% endwith %}


<br/>
<div class="container">
    <form method="POST" action="{{ url_for('views.add_to_db') }}">
        <div class="form-group">
            <label for="apiName">API Name</label>
            <input type="text" class="form-control" id="apiName" placeholder="" name="apiName" autofocus required>
        </div>
        <div class="form-group">
            <label for="apiDesc">API Description</label>
            <input type="text" class="form-control" id="apiDesc" placeholder="" name="apiDesc" autofocus required>
        </div>

        <div class="form-group">
            <label for="apiServer">API Server URL</label>
            <input type="text" class="form-control" id="apiServer" placeholder="" name="serverURL" autofocus required>
        </div>
        <div class="form-group">
            <label for="AuthCheckAPI">Authentication Check API</label>
            <input type="text" class="form-control" id="AuthCheckAPI" placeholder="" name="AuthCheckAPI" autofocus>
        </div>
        <div class="form-group">
            <label for="apiSecret">Api Secret</label>
            <input type="text" class="form-control" id="apiSecret" placeholder="" name="apiSecret" autofocus>
        </div>



        <div class="">
            <div>Routes to Expose</div>



            <div id="routes">

            </div>


            <div class="row">
                <div class="col-sm-2">
                <div class="form-group">
                    <input type="text" class="form-control" id="servicePath" name="servicePath[]" value="" placeholder="Service Path" required>
                </div>
            </div>
                <div class="col-sm-2">
                    <div class="form-group">
                        <input type="text" class="form-control" id="path" name="path[]" value="" placeholder="Endpoint Path" required>
                    </div>
                </div>

                <div class="col-sm-3">
                    <div class="form-group">
                        <input type="text" class="form-control" id="pathDesc" name="pathDesc[]" value="" placeholder="Endpoint Description" required>
                    </div>
                </div>
                <div class="col-sm-2">
                    <div class="form-group">
                        <input type="text" class="form-control" id="method" name="Method[]" value="" placeholder="Method" required>
                    </div>
                </div>

                <div class="col-sm-3">
                    <div class="form-group">
                        <div class="input-group">
                            <select class="form-control" id="authRequired" name="authRequired[]" required>

                                <option value="">Authentication Required</option>
                                <option value="true">True</option>
                                <option value="false">False</option>

                            </select>
                            <div class="input-group-btn">
                                <button class="btn btn-success" type="button"  onclick="routes();"> <span class="fa fa-plus" aria-hidden="true"></span> </button>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="clear"></div>

            </div>


        </div>
        <div class="col-auto my-1">
            <button type="submit" class="btn btn-primary btn-lg">Add</button>
        </div>
    </form>
</div>
<br/>
<script type="text/javascript">
	var room = 1;
function routes() {

    room++;



    var objTo = document.getElementById('routes')
    var divtest = document.createElement("div");
	divtest.setAttribute("class", "row form-group removeclass"+room);
	var rdiv = 'removeclass'+room;
    divtest.innerHTML = '<div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="servicePath" name="servicePath[]" value="" placeholder="service Path" required></div></div><div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="path" name="path[]" value="" placeholder="Endpoint Path" required></div></div><div class="col-sm-3"><div class="form-group"> <input type="text" class="form-control" id="pathDesc" name="pathDesc[]" value="" placeholder="Endpoint Description" required></div></div><div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="method" name="Method[]" value="" placeholder="Method" required></div></div><div class="col-sm-3"><div class="form-group"><div class="input-group"> <select class="form-control" id="authRequired" name="authRequired[]" required><option value="">Authentication Required</option><option value="true">True</option><option value="false">False</option></select><div class="input-group-btn"> <button class="btn btn-danger" type="button" onclick="remove_routes('+ room +');"> <span class="fa fa-minus" aria-hidden="true"></span> </button></div></div></div></div><div class="clear"></div>';

    objTo.appendChild(divtest)
}
   function remove_routes(rid) {
	   $('.removeclass'+rid).remove();
   }	</script>

</body>
</html>

services/API_Gateway/project/templates/base.html
<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

    <title>{{title}}</title>
  </head>
  <body>
    {% include 'navbar.html' %}
    <div class="container">

      {% block content %}

      {% endblock %}
    </div>

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
  </body>
</html>

services/API_Gateway/project/templates/home.html
{% extends 'base.html' %}

{% block content %}
<br/>
<div class="col">
    <div class="col-6">
        <h1> Welcome TO API </h1>
    </div>
    <br/>
    <div class="col-6">
            <a class="btn btn-lg btn-block btn-primary my-2 my-sm-0" href="{{ url_for('views.add') }}">Add Endpoint</a>

    </div>
    <div class="col-6">

        <br/>
            <a class="btn btn-lg btn-block btn-warning my-2 my-sm-0"  href="{{ url_for('views.all_services') }}">View Services</a>
    </div>
</div>


{% endblock %}

services/API_Gateway/project/templates/navbar.html
<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <a class="navbar-brand" href="{{ url_for('views.home') }}">API-Gateway</a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse" id="navbarNav">
    <ul class="navbar-nav">
      <li class="nav-item active">
        <a class="nav-link" href="{{ url_for('views.home') }}">Home <span class="sr-only">(current)</span></a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="{{ url_for('views.add') }}">Add</a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="{{ url_for('views.all_services') }}">Services</a>
      </li>
    </ul>
  </div>
</nav>

services/API_Gateway/project/templates/services.html
{% extends 'base.html' %}

{% block content %}
<br/>
{% with messages = get_flashed_messages(with_categories=True) %}
    {% if messages %}
        {% for cat, msg in messages %}

            <div class="container">
                <div class="alert alert-warning alert-dismissible fade show" role="alert">
                  <strong>{{ cat.capitalize() }}: </strong> {{ msg }}
                  <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
            </div>
        {% endfor %}
    {% endif %}
{% endwith %}
<br/>

{% if records %}

<br/>
<div class="container">
    <table class="table table-striped">
        <thead>
        <tr>
            <th scope="col">#</th>
            <th scope="col">Service Name</th>
            <th scope="col">Description</th>
            <th scope="col">Update</th>
            <th scope="col">Delete</th>
<!--            <th scope="col">User Filled</th>-->
<!--            <th scope="col">User Form URL</th>-->
<!--            <th scope="col">Edit</th>-->
        </tr>
        </thead>
        <tbody>
        {% for e in records %}
        <tr>
            <th scope="row">{{loop.index}}</th>
            <td><a href="{{ url_for('views.view_service', serv=e.NAME) }}">{{e.NAME}}</a></td>
            <td>{{e.DESC}}</td>
            <td>
                <form method="POST" action="{{ url_for('views.update_page') }}">
                        <button class="btn btn-warning my-2 my-sm-0" type="submit" name="Edit" value="{{ e.NAME }}">Update</button>
                </form>
            </td>
            <td>
                <form method="POST" action="{{ url_for('views.del_emp') }}">
                        <button class="btn btn-danger my-2 my-sm-0" type="submit" name="Delete" value="{{ e.NAME }}">Delete</button>
                </form>
            </td>

        </tr>
        {% endfor %}
        </tbody>
    </table>
</div>
<br/>

{% endif %}
{% endblock %}

services/API_Gateway/project/templates/update.html
<!DOCTYPE html>
<html lang="en">
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

    <!-- Optional theme -->
    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
    <link rel="stylesheet" href="../static/fa/css/font-awesome.min.css">

    <script type="text/javascript">
	var room = 1;
function routes() {

    room++;



    var objTo = document.getElementById('routes')
    var divtest = document.createElement("div");
	divtest.setAttribute("class", "row form-group removeclass"+room);
	var rdiv = 'removeclass'+room;
    divtest.innerHTML = '<div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="servicePath" name="servicePath[]" value="" placeholder="Service Path" required></div></div><div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="path" name="path[]" value="" placeholder="Endpoint Path" required></div></div><div class="col-sm-3"><div class="form-group"> <input type="text" class="form-control" id="pathDesc" name="pathDesc[]" value="" placeholder="Endpoint Description" required></div></div><div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="method" name="Method[]" value="" placeholder="Method" required></div></div><div class="col-sm-3"><div class="form-group"><div class="input-group"> <select class="form-control" id="authRequired" name="authRequired[]" required><option value="">Authentication Required</option><option value="true">True</option><option value="false">False</option></select><div class="input-group-btn"> <button class="btn btn-danger" type="button" onclick="remove_routes('+ room +');"> <span class="fa fa-minus" aria-hidden="true"></span> </button></div></div></div></div><div class="clear"></div>';

    objTo.appendChild(divtest)
}

function onloadRoutes(servicePath, path, pathD, method, trueS, falseS) {

    room++;

    var objTo = document.getElementById('routes')
    var divtest = document.createElement("div");
	divtest.setAttribute("class", "row form-group removeclass"+room);
	var rdiv = 'removeclass'+room;
    divtest.innerHTML = `<div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="servicePath" name="servicePath[]" value="${servicePath}" placeholder="${servicePath}" required></div></div><div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="path" name="path[]" value="${path}" placeholder="${path}" required></div></div><div class="col-sm-3"><div class="form-group"> <input type="text" class="form-control" id="pathDesc" name="pathDesc[]" value="${pathD}" placeholder="${pathD}" required></div></div><div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="method" name="Method[]" value="${method}" placeholder="${method}" required></div></div><div class="col-sm-3"><div class="form-group"><div class="input-group"> <select class="form-control" id="authRequired" name="authRequired[]" required><option value="">Authentication Required</option><option value="true" ${trueS}>True</option><option value="false" ${falseS}>False</option></select><div class="input-group-btn"><button class="btn btn-danger" type="button" onclick="remove_routes(${room});"> <span class="fa fa-minus" aria-hidden="true"></span> </button></div></div></div></div><div class="clear"></div>`;

    objTo.appendChild(divtest)
}
   function remove_routes(rid) {
	   $('.removeclass'+rid).remove();
   }

</script>

    <title>{{title}}</title>
</head>
<body>
{% include 'navbar.html' %}
<br/>


{% with messages = get_flashed_messages(with_categories=True) %}
{% if messages %}
{% for cat, msg in messages %}

<div class="container">
    <div class="alert alert-warning alert-dismissible fade show" role="alert">
        <strong>{{ cat.capitalize() }}: </strong> {{ msg }}
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
</div>
{% endfor %}
{% endif %}
{% endwith %}


<br/>
<div class="container">
    <form method="POST" action="{{ url_for('views.update_serv') }}">
        <div class="form-group">
            <label for="apiName">API Name</label>
            <input type="text" class="form-control" id="apiName" placeholder="{{ records.NAME }}" value="{{ records.NAME }}" name="apiName" autofocus required>
        </div>
        <div class="form-group">
            <label for="apiDesc">API Description</label>
            <input type="text" class="form-control" id="apiDesc" placeholder="{{ records.DESC }}" value="{{ records.DESC }}" name="apiDesc" autofocus required>
        </div>

        <div class="form-group">
            <label for="apiServer">API Server URL</label>
            <input type="text" class="form-control" id="apiServer" placeholder="{{records.URL}}" value={{records.URL}} name="serverURL" autofocus required>
        </div>
        <div class="form-group">
            <label for="AuthCheckAPI">Authentication Check API</label>
            <input type="text" class="form-control" id="AuthCheckAPI" placeholder="{{records.AUTH_CHECK_API}}" value="{{records.AUTH_CHECK_API}}" name="AuthCheckAPI" autofocus>
        </div>
        <div class="form-group">
            <label for="apiSecret">Api Secret</label>
            <input type="text" class="form-control" id="apiSecret" placeholder="{{records.API_SECRET}}" value="{{records.API_SECRET}}" name="apiSecret" autofocus>
        </div>



        <div class="">
            <div class="font-weight-bold">Routes to Expose</div>





            <div id="routes">

            </div>
            {% for ep in records.ROUTES %}
                <script type="text/javascript">
                    {% set t='`selected`' if ep.authRequired == 'true' else ""|tojson %}
                    {% set f= '`selected`' if ep.authRequired == 'false' else ""|tojson %}
                    var path={{ ep.path|tojson }};
                    var servPath={{ ep.servicePath|tojson }};
                    var desc={{ ep.pathDesc|tojson }};
                    var method={{ ep.method|tojson }};
                    var t = {{t}};
                    var f = {{f}};

                    window.onloadRoutes(servPath, path, desc, method, t, f);
                </script>
            {% endfor %}
            <div class="input-group-btn">
                <button class="btn btn-success" type="button"  onclick="routes();"> Add New Endpoint </button>
            </div>


        </div>

        <div class="col-auto my-1">
            <button type="submit" class="btn btn-primary btn-lg" name="Edit" value="{{ records.NAME }}">Update</button>
        </div>
    </form>
</div>
<br/>



</body>
</html>

services/API_Gateway/project/templates/view_service.html
{% extends 'base.html' %}
#TODO fo fix the endpoint loop...
{% block content %}
<br/>

{% with messages = get_flashed_messages(with_categories=True) %}
{% if messages %}
{% for cat, msg in messages %}

<div class="container">
    <div class="alert alert-warning alert-dismissible fade show" role="alert">
        <strong>{{ cat.capitalize() }}: </strong> {{ msg }}
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
</div>
{% endfor %}
{% endif %}
{% endwith %}

{% if records %}

<br/>
<div class="container">
    <table class="table table-striped">
        <!--        <thead>-->
        <!--        <tr>-->
        <!--            <th scope="col">#</th>-->
        <!--            <th scope="col">Service Name</th>-->
        <!--            <th scope="col">Description</th>-->
        <!--            <th scope="col">Update</th>-->
        <!--&lt;!&ndash;            <th scope="col">User Filled</th>&ndash;&gt;-->
        <!--&lt;!&ndash;            <th scope="col">User Form URL</th>&ndash;&gt;-->
        <!--&lt;!&ndash;            <th scope="col">Edit</th>&ndash;&gt;-->
        <!--        </tr>-->
        <!--        </thead>-->
        <tbody>

        <tr>
            <th scope="row">Name</th>
            <td>{{records.NAME}}</td>

        </tr>
        <tr>
            <th scope="row">Description</th>
            <td>{{records.DESC}}</td>
        </tr>
        <tr>
            <th scope="row">Server URL</th>
            <td>{{records.URL}}</td>
        </tr>
        <tr>
            <th scope="row">Authentication Check API</th>
            <td>{{records.AUTH_CHECK_API}}</td>
        </tr>
        <tr>
            <th scope="row">API SECRET</th>
            <td>{{records.API_SECRET}}</td>
        </tr>
        <tr>
            <th scope="row">End Points</th>
            <td>
                {% for ep in records.ROUTES %}
                <div class="font-weight-bold p-1 bg-warning text-dark"> Service Path:  {{ prefix }}{{ ep.servicePath }}<br/></div>
                <strong>Path: </strong> {{ ep.path }}<br/>
                <strong>Description: </strong> {{ ep.pathDesc }}<br/>
                <strong>Method: </strong>{{ ep.method }}<br/>
                <strong>Authentication required: </strong>{{ ep.authRequired }}
                <br/>
                <br/>
                {% endfor %}
            </td>
        </tr>

        </tbody>
    </table>

    <div class="row">
        <div class="col-6">
            <form method="POST" action="{{ url_for('views.update_page') }}">
                <button class="btn btn-lg btn-block btn-primary my-2 my-sm-0" type="submit" name="Edit" value="{{ records.NAME }}">Update</button>
            </form>
        </div>
        <div class="col-6">
            <form method="POST" action="{{ url_for('views.del_emp') }}">
                <button class="btn btn-lg btn-block btn-danger my-2 my-sm-0" type="submit" name="Delete" value="{{ records.NAME }}">Delete</button>
            </form>
        </div>
    </div>

</div>
<br/>

{% endif %}
{% endblock %}